#include "p33Fxxxx.h"
#include <stdint.h>

#define SYS_FREQ 80000000UL
#define FCY SYS_FREQ/2
#define delay_us(x) __delay32(((x*FCY)/1000000L))

_FOSCSEL(0x02);
_FOSC(0xE2);

void __delay32(unsigned long cycles);

unsigned int i = 0,
			 sinus64[64] = {500, 549, 598, 645, 691, 736, 778, 817, 854, 887, 916, 941, 962, 978, 990, 998, 1000, 998, 990, 978, 962, 941, 916, 887, 854, 817, 778, 736, 691, 645, 598, 549, 500, 451, 402, 355, 309, 264, 222, 183, 146, 113, 84, 59, 38, 22, 10, 2, 0, 2, 10, 22, 38, 59, 84, 113, 146, 183, 222, 264, 309, 355, 402, 451},
			 sinus16[16]= {500, 691, 854, 962, 1000, 962, 854, 691, 500, 309, 146, 38, 0, 38, 146, 309};


int main(void)
{

	OC1CONbits.OCM = 0b000;		//   Output Compare
	OC1R = 100;					//     
	OC1RS = 200;				//     
								//   

	OC1CONbits.OCTSEL = 0;		//  Timer 2 ( )
	OC1CONbits.OCM = 0b110;		//   Output Compare
								// 110 -      
								// 111 -      

	T2CON = 0;					// ensure Timer 2 is in reset state
	T2CONbits.TON = 0;			// Disable Timer
	T2CONbits.TCS = 0;			//     
	T2CONbits.TGATE = 0;		//  Gated Timer mode
	T2CONbits.TCKPS = 0b00;		//   1:1 
	TMR2 = 0x00;				//  
	PR2 = 500;					//  
	IPC1bits.T2IP = 1;			//    Timer 2
	IFS0bits.T2IF = 0;			//    Timer 2 
	IEC0bits.T2IE = 1;			//    Timer 2
	T2CONbits.TON = 1;			//  Timer

	// 100Hz
	// 1.5V

	while(1){ };
}


void __attribute__((__interrupt__)) _T2Interrupt( void )
{
	OC1RS = sinus64[i];
	i++;
	i %= 64;
	IFS0bits.T2IF = 0;		//    Timer 2
}
